love.filesystem.setIdentity('MapMaker')
require('saveTable')
require('entities')
fonts = {}
fonts[12] = love.graphics.newFont(11)
fonts[30] = love.graphics.newFont(30)
love.graphics.setFont(fonts[30])

msgWindow = love.graphics.newImage('msgWindow.png')
msgWindow:setFilter('nearest','nearest')
tileset = love.graphics.newImage('pkmnTiles.png')
tileset:setFilter('nearest','nearest')

--fontImage = love.graphics.newImageFont("font.png", "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890")


player = love.graphics.newImage('playerIcon.png')
tileSize = 16
tiles = {}
map = { {}, {}, {}, {},{}, script = {}, objectScripts = { {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {},}, }
layerNames = {
	'Background',
	'Collisions',
	'Foreground',
	'Entities',
	'middleBackground',
}
currentLayer = 2
numTiles = 50
placeType = 'map'
selected = {X=3,Y=2}
selectedEnt = 1
keyIndex = {}
function getTile(n)
	return (math.ceil(n/tileSize))
end

function getPixel(n)
	return (n*tileSize)
end

function string.firstToUpper(str)
    return (str:gsub("^%l", string.upper))
end




function love.load()
	for i = 1, numTiles do
		marginX = (1*i)-1
		
		for k = 1, numTiles do
			marginY = (1*k)-1
			local quad = love.graphics.newQuad( (tileSize*i)-tileSize+marginX, (tileSize*k)-tileSize+marginY, tileSize, tileSize, tileset:getWidth(), tileset:getHeight() )
			
			if not(tiles[i]) then tiles[i] = {} end
			tiles[i][k] = {quad=quad}
		end
	end
	
		if love.filesystem.exists('map1.pkm') then
			local tempFile ,bytes= love.filesystem.read('map1.pkm')
			
			map = table.load(tempFile)
			if not(map.objectScripts) then map.objectScripts = { {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {},} end
			
		end
end

function love.update()
	local X = love.mouse.getX()
	local Y = love.mouse.getY()
	local tileX = getTile(X)
	local tileY = getTile(Y)

	if not(currentFunc) then
	
		tileMenu = (love.keyboard.isDown('`') or love.keyboard.isDown('~'))
		entMenu = (love.keyboard.isDown('`') or love.keyboard.isDown('~'))

		if (love.keyboard.isDown('lctrl') or love.keyboard.isDown('rctrl')) and love.keyboard.isDown('f') then
			for x = 1, getTile(love.graphics.getWidth()) do
				for y = 1, getTile(love.graphics.getHeight()) do
					if not(map[currentLayer][x]) then map[currentLayer][x] = {} end
				
					map[currentLayer][x][y] = {X = selected.X, Y = selected.Y}
				end
			
			end
		end
		
		if (love.keyboard.isDown('lctrl') or love.keyboard.isDown('rctrl')) and love.keyboard.isDown('delete') then
			map[currentLayer] = {}
		end
		
		if love.mouse.isDown('l') and not(tileMenu) and selected  then
			if placeType == 'map' then
				if not(map[currentLayer]) then map[currentLayer] = {} end
				if not(map[currentLayer][tileX]) then map[currentLayer][tileX] = {} end
				map[currentLayer][tileX][tileY] = {X = selected.X, Y = selected.Y}
				if love.keyboard.isDown('lshift') then
					if tileX-1 > 0 then
						if not(map[currentLayer][tileX-1]) then map[currentLayer][tileX-1] = {} end
						if not(map[currentLayer][tileX+1]) then map[currentLayer][tileX+1] = {} end
						
						map[currentLayer][tileX+1][tileY] = {X = selected.X, Y = selected.Y}
						map[currentLayer][tileX][tileY+1] = {X = selected.X, Y = selected.Y}
						map[currentLayer][tileX+1][tileY+1] = {X = selected.X, Y = selected.Y}
					

					
						map[currentLayer][tileX-1][tileY] = {X = selected.X, Y = selected.Y}
						map[currentLayer][tileX][tileY-1] = {X = selected.X, Y = selected.Y}
						map[currentLayer][tileX-1][tileY-1] = {X = selected.X, Y = selected.Y}

						map[currentLayer][tileX+1][tileY-1] = {X = selected.X, Y = selected.Y}
						map[currentLayer][tileX-1][tileY+1] = {X = selected.X, Y = selected.Y}
					end
				end
			elseif placeType == 'player' then
				map.script.playerStart = {X=tileX-1,Y=tileY-1}
			elseif placeType == 'delete' then
				if map.objectScripts[tileX] and  map.objectScripts[tileX][tileY] then 
					map.objectScripts[tileX][tileY] = nil

				else
					if map[currentLayer][tileX] and  map[currentLayer][tileX][tileY] then 
						map[currentLayer][tileX][tileY] = nil
					end
				end
			end
		end
		
		if love.keyboard.isDown('lctrl') and love.keyboard.isDown('s') then
			local data = table.save(map)
			love.filesystem.write('map1.pkm', data)
		end
	end
end

function love.mousepressed(x,y,key)
	local tileX = getTile(x)
	local tileY = getTile(y)
	if not(currentFunc) then
	
		if placeType =='map' then
			if key == 'l' and tileX <= numTiles and tileY <= numTiles and tileMenu then
				selected = {X = tileX, Y = tileY}
			end
		elseif placeType =='entities' then
			if key == 'l' then
				if entMenu then 
					local z = ((((tileY-1)*5)-5)+(tileX-1))
					if entities[z] then
						selectedEnt = (z)
					end
				else
					entities:add(selectedEnt, tileX, tileY)
				end
			end
		end
	end
end


function love.keypressed(key,unicode)
	if unicode > 0 then
		keyIndex[unicode] = true
		keyIndex['curKey'] = unicode
	end


	if not(currentFunc) then

		if key == 'f1' then
			placeType = 'map'
		elseif key == 'f2' then
			placeType = 'player'
		elseif key == 'f3' then
			placeType = 'delete'
		elseif key == 'f4' then
			placeType = 'entities'
		end
		
		if tonumber(key) then
			if (tonumber(key) < 4 or tonumber(key) == 5) and tonumber(key) > 0 then
				currentLayer = tonumber(key)
			end
		end
	end
end

function love.draw()
	love.graphics.setFont(fonts[30])

	local X = love.mouse.getX()
	local Y = love.mouse.getY()
	local tileX = (math.ceil(X/tileSize))
	local tileY = (math.ceil(Y/tileSize))

	if tileMenu then love.graphics.setColor(255,255,255,80) end

	--Draw Map
	for o,p in pairs(map) do
		if not(o  == 'script') and not(o  == 'objectScripts') then
			for i,v in pairs(p) do
				for k,d in pairs(v) do
					if not(love.keyboard.isDown('f12')) and type(d)=='table' then 
						love.graphics.drawq(tileset, tiles[d.X][d.Y].quad, (tileSize*i)-tileSize,  (tileSize*k)-tileSize)
						if o == 2 then
							entities:draw()
						end
					else
						if o ==1 then love.graphics.setColor(123,0,255) end
						if o ==2 then love.graphics.setColor(0,123,255) end
						if o ==3 then love.graphics.setColor(255,123,0) end
					
						love.graphics.rectangle('fill', (tileSize*i)-tileSize,  (tileSize*k)-tileSize,16,16)
					end
				end
			end
		end
	end
	

	--Draw PlayerIcon
	if map.script and map.script.playerStart then
		love.graphics.draw(player, getPixel(map.script.playerStart.X), getPixel(map.script.playerStart.Y) )
	end
	
	--Correct Colours
	love.graphics.setColor(255,255,255,255)	

	
	--Draw Tilemap
	if tileMenu and not(placeType == 'entities') then	
		for i,v in ipairs(tiles) do
			for k,d in ipairs(v) do
				love.graphics.drawq(tileset, d.quad, (tileSize*i)-tileSize,  (tileSize*k)-tileSize)
			end
		end
	
	
		if tileX <= numTiles  and tileY <= numTiles then
			love.graphics.rectangle('line', (tileSize*tileX)-tileSize, (tileSize*tileY)-tileSize, tileSize, tileSize)
		end
	
		if tileX <= numTiles  and tileY <= numTiles then
				love.graphics.rectangle('line', (tileSize*tileX)-tileSize, (tileSize*tileY)-tileSize, tileSize, tileSize)
		end
		
	end

	
	
	
	--Draw entities menu
	if entMenu and (placeType == 'entities') then	
		for i,v in pairs(entities) do
			if type(v) == 'table' then
				local x = i+1
				local y = math.ceil(i/5)+1
				x = (i+1)-((y*5)-10)
				if tiles[v.X] and tiles[v.X][v.Y] then 
					love.graphics.drawq(tileset, tiles[v.X][v.Y].quad, (tileSize*x)-tileSize,  (tileSize*y)-tileSize)
				end
			end
		end
	
	
		if tileX <= numTiles  and tileY <= numTiles then
			love.graphics.rectangle('line', (tileSize*tileX)-tileSize, (tileSize*tileY)-tileSize, tileSize, tileSize)
		end
	
		if tileX <= numTiles  and tileY <= numTiles then
				love.graphics.rectangle('line', (tileSize*tileX)-tileSize, (tileSize*tileY)-tileSize, tileSize, tileSize)
		end
	end

	
	if not(currentFunc) then
	if not(tileMenu) and not(entMenu) then

		--Draw shadowed images (for placement help)
		love.graphics.setColor(255,255,255,100)
		if placeType == 'map' then
			if love.keyboard.isDown('lshift') then
					love.graphics.drawq(tileset, tiles[selected.X][selected.Y].quad, (tileSize*(tileX+1))-tileSize,  (tileSize*(tileY+1))-tileSize)
					love.graphics.drawq(tileset, tiles[selected.X][selected.Y].quad, (tileSize*(tileX))-tileSize,  (tileSize*(tileY+1))-tileSize)
					love.graphics.drawq(tileset, tiles[selected.X][selected.Y].quad, (tileSize*(tileX-1))-tileSize,  (tileSize*(tileY+1))-tileSize)
					
					love.graphics.drawq(tileset, tiles[selected.X][selected.Y].quad, (tileSize*(tileX-1))-tileSize,  (tileSize*(tileY-1))-tileSize)
					love.graphics.drawq(tileset, tiles[selected.X][selected.Y].quad, (tileSize*(tileX))-tileSize,  (tileSize*(tileY-1))-tileSize)
					love.graphics.drawq(tileset, tiles[selected.X][selected.Y].quad, (tileSize*(tileX+1))-tileSize,  (tileSize*(tileY-1))-tileSize)
					
					love.graphics.drawq(tileset, tiles[selected.X][selected.Y].quad, (tileSize*(tileX+1))-tileSize,  (tileSize*(tileY))-tileSize)
					love.graphics.drawq(tileset, tiles[selected.X][selected.Y].quad, (tileSize*(tileX-1))-tileSize,  (tileSize*(tileY))-tileSize)
			end
			love.graphics.drawq(tileset, tiles[selected.X][selected.Y].quad, (tileSize*tileX)-tileSize,  (tileSize*tileY)-tileSize)
		elseif placeType == 'entities' then
			local ent = entities[selectedEnt]
			love.graphics.drawq(tileset, tiles[ent.X][ent.Y].quad, (tileSize*tileX)-tileSize,  (tileSize*tileY)-tileSize)
		elseif placeType == 'player' then
			love.graphics.draw(player,(tileSize*(tileX))-tileSize,(tileSize*(tileY))-tileSize)
		end
		love.graphics.setColor(255,255,255,255)

		--Draw Layer Name and Placement Type
		local font = love.graphics.getFont( )
		love.graphics.print(string.firstToUpper(layerNames[currentLayer]), (love.graphics.getWidth()-font:getWidth(layerNames[currentLayer]))-16,5)
		love.graphics.print(string.firstToUpper(placeType), 16,5)
	end
	
	end
	
	entities:addRun()	
	keyIndex = {}
end


















