local playerSprites = love.graphics.newImage('playerIcon.png')
playerSprites:setFilter('nearest','nearest')

player = {
	standing = {
		down = love.graphics.newQuad( 0, 0, 17, 25, playerSprites:getWidth(), playerSprites:getHeight() ),
		up = love.graphics.newQuad( 102, 0, 17, 25, playerSprites:getWidth(), playerSprites:getHeight() ),
		left = love.graphics.newQuad( 153, 0, 17, 25, playerSprites:getWidth(), playerSprites:getHeight() ),
		right = love.graphics.newQuad( 51, 0, 17, 25, playerSprites:getWidth(), playerSprites:getHeight() ),
	},
	walking = {
		down = newImageAnimation(playerSprites, 0.4,{{17, 0, 17, 25}, {34, 0, 17, 25}}),
		up = newImageAnimation(playerSprites, 0.4,{{119, 0, 17, 25},{136, 0, 17, 25}}),
		left = newImageAnimation(playerSprites, 0.4,{{170, 0, 17, 25},{187, 0, 17, 25},}),
		right = newImageAnimation(playerSprites, 0.4,{{68, 0, 17, 25},{85, 0, 17, 25}}),
	},
	rise = 0, 
	run = 0, 
	moving = false, 
	facing = 'down',
	spriteBatch = {
		up =  love.graphics.newSpriteBatch( playerSprites, 10 ),
		down =  love.graphics.newSpriteBatch( playerSprites, 10 ),
		left =  love.graphics.newSpriteBatch( playerSprites, 10 ),
		right =  love.graphics.newSpriteBatch( playerSprites, 10 ),
	}

}


function player.checkCollision(x,y)
	if map[2][math.ceil(x)+1] and map[2][math.ceil(x)+1][math.ceil(y)+1] then
		return true
	elseif map.objectScripts[math.ceil(x)+1] and map.objectScripts[math.ceil(x)+1][math.ceil(y)+1] then

		return true
	end
end

function player.getSpeed()
	return 1
end

function player.getTile()
	return math.ceil(player.X), math.ceil(player.Y)
end

function player.getPixel()
	local pX,pY = player.getTile()
	return getPixel(pX), getPixel(pY)
end

function player.draw()
	if player.moving then
		player.walking[player.facing]:draw(player.drawX, player.drawY)
	else
		love.graphics.drawq(playerSprites, player.standing[player.facing], player.drawX, player.drawY)	
	end

end

function player.move()
	if (player.moving) then
		local distance = math.sqrt((getPixel(player.X) - player.drawX)^2 + (getPixel(player.Y) - player.drawY)^2)

		
		if distance < 1 then 
		--	player.drawX = getPixel(player.X)
		--	player.drawY = getPixel(player.Y)
			player.moving = false
		else
			player.drawX = 	player.drawX+player.run
			player.drawY = 	player.drawY+player.rise
		end
	end
	if not(player.moving) then

		if love.keyboard.isDown('w') or love.keyboard.isDown('up') then
			player.facing = 'up'
		elseif love.keyboard.isDown('a') or love.keyboard.isDown('left') then

			player.facing = 'left'
		elseif love.keyboard.isDown('s') or love.keyboard.isDown('down') then

			player.facing = 'down'
		elseif love.keyboard.isDown('d') or love.keyboard.isDown('right') then

			player.facing = 'right'
		end
		
		if (love.keyboard.isDown('w') or love.keyboard.isDown('up')) and not(player.checkCollision(player.X,player.Y-player.getSpeed())) then
			player.Y = player.Y-player.getSpeed()
			player.facing = 'up'
			player.moving = true
		elseif (love.keyboard.isDown('a') or love.keyboard.isDown('left')) and not(player.checkCollision(player.X-player.getSpeed(), player.Y)) then
			player.X = player.X-player.getSpeed()
			player.moving = true
			player.facing = 'left'
		elseif (love.keyboard.isDown('s') or love.keyboard.isDown('down')) and not(player.checkCollision(player.X,player.Y+player.getSpeed())) then
			player.Y = player.Y+player.getSpeed()
			player.moving = true
			player.facing = 'down'
		elseif (love.keyboard.isDown('d') or love.keyboard.isDown('right')) and not(player.checkCollision(player.X+player.getSpeed(), player.Y)) then
			player.X = player.X+player.getSpeed()
			player.moving = true
			player.facing = 'right'
		end
		
		player.run = (((getPixel(player.X) - player.drawX)))/16
		player.rise = (((getPixel(player.Y) - player.drawY)))/16
	end



end

















